% K = gaussiankernel(xr, xc, ss)
% RBF kernel implementation. 
% K(i,j) = exp(-0.5*|xr(i,:) - xc(j,:)|^2/ss^2 
%
% EPH, G2PI/DTSC/UC3M
% Nov 25, 2009.
%

function K = gaussiankernel(xr,xc,ss)
[Nr,dr] = size(xr);
[Nc,dc] = size(xc);
if dc ~= dr
    disp('different data dimension')
    return
end

xr2 = sum(xr.*xr,2);
xc2 = sum(xc.*xc,2);

K=[];

if Nr > Nc
    for j=1:100:Nr
        if j+100-1 < Nr
            fin = j+100-1;
        else    
            fin=Nr;
        end
        K = [K;xr(j:fin,:)*xc'];
    end
else
    for i=1:100:Nc
        if i+100-1 < Nc
            fin = i+100-1;
        else
            fin=Nc;
        end
        K=[K xr*(xc(i:fin,:))'];
    end
end
K = repmat(xr2,1,Nc) + repmat(xc2',Nr,1) - 2*K;
K = exp(-0.5/ss/ss*K);