#include <math.h>
#include "mex.h"

void inv_kl(double *qd, double *qs, double *kl, int N)
{
  int i;
  double izq,dch,ikl=0,p;
  
  for(i=0;i<N;i++){
    izq=qs[i];
    dch = 1-1e-10;
    while((dch-izq)/dch>=1e-5){
      p=(izq+dch)*.5;
      ikl=kl[i]-(qs[i]*log(qs[i]/p)+(1-qs[i])*log((1-qs[i])/(1-p)));
      if(ikl<0)
	dch=p;
      else
	izq=p;
    }
    qd[i] = p;
  }
} 


void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
  double *qd, *qs, *kl, *paso;
  int N,i;
  
  N = mxGetN(prhs[0]);
  plhs[0] = mxCreateDoubleMatrix(1,N, mxREAL);
  qs = (double *) mxCalloc(N, sizeof(double));
  kl =(double *) mxCalloc(N, sizeof(double));

  paso = mxGetPr(prhs[0]);

  for(i = 0; i < N; i++)
    qs[i] = paso[i];

  paso = mxGetPr(prhs[1]);
  for(i = 0; i < N; i++)
    kl[i] = paso[i];

  qd = mxGetPr(plhs[0]);
  inv_kl(qd, qs, kl,N);
  mxFree(qs);
  mxFree(kl);
}
